const axios = require("axios");
const { vehicle } = require("../model");
const pdf = require("html-pdf");
const ejs = require("ejs");
const path = require("path");
const puppeteer = require("puppeteer");
const fs = require("fs");
const { chromium } = require("playwright");
const Car = require("../model/VechicleDB.js");
const http=require("http")
const sequelize = require("../connect/postgresqlConnnection.js");


async function getLatLonByPostalCode(postalCode) {
  const url = `https://nominatim.openstreetmap.org/search?format=json&q=${encodeURIComponent(postalCode)}`;
  const response = await axios.get(url);
  return response.data.length > 0 ? { lat: response.data[0].lat, lon: response.data[0].lon } : null;
}

const carMarketValue = async (req, res, next) => {
  try {
    const { vin } = req.params;
    const options = {
      method: "GET",
      url: `https://api.vehicledatabases.com/premium/vin-decode/${vin}`,
      headers: {
        "x-AuthKey": `${process.env.VEHICLE_DB}`,
      },
    };
    const response = await axios(options);
    return res.status(200).json({
      message: "Fetched Successfully",
      result: response.data,
    });
  } catch (err) {
    return res.status(500).json({
      message: "Internal Error.",
      data: err,
    });
  }
};

const carinfoByVin = async (req, res, next) => {
  try {
    const { vin } = req.params;
    let options = {
      method: "GET",
      url: `https://auto.dev/api/vin/${vin}?`,
      headers: {
        apiKey: `${process.env.AUTO_DEV_KEY}`,
      },
    };
    const listing = await axios(options);
    return res.status(200).json({
      message: "Car Info by Vin Decode",
      result: listing.data,
    });
  } catch (err) {
    next(err);
  }
};
//-----------
// const carListing = async (req, res, next) => {
//   try {
//     console.log(req.query," payload")
//     let baseUrl = `https://auto.dev/api/listings`;
//     const capitalize = (str) => str.charAt(0).toUpperCase() + str.slice(1).toLowerCase();

//     if (req.query) {
//       baseUrl += `?`;
//     }
//     // if (req.query.condition) {
//     //   baseUrl += `condition=${req.query.condition}`;
//     // }
//     // if (req.query.price_min) {
//     //   baseUrl += `&price_min=${req.query.price_min}`;
//     // }
//     // if (req.query.price_max) {
//     //   baseUrl += `&price_max=${req.query.price_max}`;
//     // }
//     // if (req.query.postal_code) {
//     //   const location = await getLatLonByPostalCode(req.query.postal_code);
//     //   if (!location) {
//     //     return res.status(400).json({ message: "Invalid zip code" });
//     //   }
//     //   baseUrl += `latitude=${location.lat}&longitude=${location.lon}&radius=${req.query.radius}`;
//     // }
//     // if (req.query.model) {
//     //   const capitalizedModel =
//     //     req.query.model.charAt(0).toUpperCase() + req.query.model.slice(1);
//     //   baseUrl += `&model=${capitalizedModel}`;
//     // }
    
//     // if (req.query.year_max) {
//     //   baseUrl += `&year_max=${req.query.year_max}`;
//     // }
//     // if (req.query.year_min) {
//     //   baseUrl += `&year_min=${req.query.year_min}`;
//     // }

//     // if (req.query.body_style) {
//     //   baseUrl += `&body_style=${req.query.body_style}`;
//     // }
//     // if (req.query.page) {
//     //   baseUrl += `&page=${req.query.page}`;
//     // }
//     // if (req.query.city) {
//     //   baseUrl += `&city=${req.query.city}`;
//     // }
//     // if (req.query.mileage) {
//     //   baseUrl += `&max_mileage=50000`;
//     // } 
//     // if (req.query.trim) {
//     //   baseUrl += `&trim=${req.query.trim}`;
//     // }
//     // if (req.query.make) {
//     //   const makeLength = req.query.make.split(" ");
//     //   if (makeLength.length > 1) {
//     //     let make =
//     //       makeLength[0].charAt(0).toUpperCase() + makeLength[0].slice(1);
//     //     let model =
//     //       makeLength[1].charAt(0).toUpperCase() + makeLength[1].slice(1);
//     //     baseUrl += `&make=${make}&model=${model}`;
//     //   } else {
//     //     const capitalizedMake =
//     //       req.query.make.charAt(0).toUpperCase() + req.query.make.slice(1);
//     //     baseUrl += `&make=${capitalizedMake}`;
//     //   }
//     // }

//     if (req.query.condition) {
//       baseUrl += `condition=${req.query.condition}`;
//     }
//     if (req.query.price_min) {
//       baseUrl += `&price_min=${req.query.price_min}`;
//     }
//     if (req.query.price_max) {
//       baseUrl += `&price_max=${req.query.price_max}`;
//     }
//     if (req.query.postal_code) {
//       const location = await getLatLonByPostalCode(req.query.postal_code);
//       if (!location) {
//         return res.status(400).json({ message: "Invalid zip code" });
//       }
//       baseUrl += `latitude=${location.lat}&longitude=${location.lon}&radius=${req.query.radius}`;
//     }
//     if (req.query.model) {
//       baseUrl += `&model=${capitalize(req.query.model)}`;
//     }
//     if (req.query.year_max) {
//       baseUrl += `&year_max=${req.query.year_max}`;
//     }
//     if (req.query.year_min) {
//       baseUrl += `&year_min=${req.query.year_min}`;
//     }
//     if (req.query.body_style) {
//       baseUrl += `&body_style=${capitalize(req.query.body_style)}`;
//     }
//     if (req.query.page) {
//       baseUrl += `&page=${req.query.page}`;
//     }
//     if (req.query.city) {
//       baseUrl += `&city=${capitalize(req.query.city)}`;
//     }
//     if (req.query.mileage) {
//       baseUrl += `&max_mileage=50000`;
//     }
//     if (req.query.trim) {
//       baseUrl += `&trim=${capitalize(req.query.trim)}`;
//     }
//     if (req.query.make) {
//       const makeLength = req.query.make.split(" ");
//       if (makeLength.length > 1) {
//         let make = capitalize(makeLength[0]);
//         let model = capitalize(makeLength[1]);
//         baseUrl += `&make=${make}&model=${model}`;
//       } else {
//         const capitalizedMake = capitalize(req.query.make);
//         baseUrl += `&make=${capitalizedMake}`;
//       }
//     }
    
//     console.log(baseUrl," baseURL")
//     let option = {
//       method: "GET",
//       url: baseUrl,
//       headers: {
//         apiKey: `${process.env.AUTO_DEV_KEY}`,
//       },
//     };
//     const response = await axios(option);
//     return res.status(200).json({
//       message: "Car List",
//       result: response.data,
//     });
//   } catch (err) {
//     return res.status(500).json({
//       message:err.message
//     })
//   }
// };


const carListing = async (req, res, next) => {
  try {
    console.log(req.query.mileage, "payload");
    let baseUrl = `https://auto.dev/api/listings`;
    const capitalize = (str) => str.charAt(0).toUpperCase() + str.slice(1).toLowerCase();

    if (req.query) {
      baseUrl += `?`;
    }

    if (req.query.condition) {
      baseUrl += `condition=${req.query.condition}`;
    }
    if (req.query.price_min) {
      baseUrl += `&price_min=${req.query.price_min}`;
    }
    if (req.query.price_max) {
      baseUrl += `&price_max=${req.query.price_max}`;
    }
    if (req.query.postal_code) {
      const location = await getLatLonByPostalCode(req.query.postal_code);
      if (!location) {
        return res.status(400).json({ message: "Invalid zip code" });
      }
      baseUrl += `latitude=${location.lat}&longitude=${location.lon}&radius=${req.query.radius}`;
    }
    if (req.query.model) {
      baseUrl += `&model=${capitalize(req.query.model)}`;
    }
    if (req.query.year_max) {
      baseUrl += `&year_max=${req.query.year_max}`;
    }
    if (req.query.year_min) {
      baseUrl += `&year_min=${req.query.year_min}`;
    }
    if (req.query.body_style) {
      baseUrl += `&body_style=${capitalize(req.query.body_style)}`;
    }
    if (req.query.page) {
      baseUrl += `&page=${req.query.page}`;
    }
    if (req.query.city) {
      baseUrl += `&city=${capitalize(req.query.city)}`;
    }
    if (req.query.mileage && req.query.mileage.trim() !== "") {
      baseUrl += `&mileage=${req.query.mileage}`;
    }
    
    if (req.query.trim) {
      baseUrl += `&trim=${capitalize(req.query.trim)}`;
    }
    if (req.query.make) {
      const makeLength = req.query.make.split(" ");
      if (makeLength.length > 1) {
        let make = capitalize(makeLength[0]);
        let model = capitalize(makeLength[1]);
        baseUrl += `&make=${make}&model=${model}`;
      } else {
        const capitalizedMake = capitalize(req.query.make);
        baseUrl += `&make=${capitalizedMake}`;
      }
    }

    console.log(baseUrl, "baseURL");
    let option = {
      method: "GET",
      url: baseUrl,
      headers: {
        apiKey: `${process.env.AUTO_DEV_KEY}`,
      },
    };
    
    const response = await axios(option);
    return res.status(200).json({
      message: "Car List",
      result: response.data,
    });
  } catch (err) {
    console.log(err.message)
    return res.status(500).json({
      message: err.message,
    });
  }
};


//------------ending

const premiumPlusVinDecode = async (req, res) => {
  try {
    const vin = req.params.vin;
    const options = {
      method: "GET",
      url: `https://api.vehicledatabases.com/advanced-vin-decode/${vin}`,
      headers: {
        "x-AuthKey": `${process.env.VEHICLE_DB}`,
      },
    };
    const response = await axios(options);
    return res.status(200).json(response.data);
  } catch (error) {
    res.status(500).send("An error occurred");
  }
};

const saleHistory = async (req, res, next) => {
  try {
    const { vin } = req.params;
    let option = {
      method: "GET",
      url: `https://api.vehicledatabases.com/saleshistory/${vin}`,
      headers: {
        "x-authKey": `${process.env.VEHICLE_DB}`,
      },
    };
    const response = await axios(option);
    return res.status(200).json({
      message: "Sale History on the basis of Vin Code",
      result: response.data,
    });
  } catch (err) {
    return res.status(200).json({
      message: "Sale History on the basis of Vin Code",
      result: [],
    });
  }
};

//----------------------------------------------------------




////working code for salvage car list

const salvageCarListbyPost = async (req, res) => {
  try {
    const page = parseInt(req.query.page, 10) || 1;
    const limit = parseInt(req.query.limit, 10) || 20;
    const offset = (page - 1) * limit;

    let { model, manufacturer, year, postal_code, mileage_min, mileage_max, year_min, year_max, latitude, longitude, radius, title } = req.query;

    let whereClauses = [];
    let replacements = { limit, offset };

    if (manufacturer) {
      whereClauses.push("man.name ILIKE :manufacturer");
      replacements.manufacturer = `%${manufacturer}%`;
    }
    if (model) {
      whereClauses.push("model.name ILIKE :model");
      replacements.model = `%${model}%`;
    }
    if (title) {
      whereClauses.push("car.title ILIKE :title");
      replacements.title = `%${title}%`;
    }
    if (year) {
      whereClauses.push("car.year = :year");
      replacements.year = parseInt(year, 10);
    }
    if (year_min) {
      whereClauses.push("car.year >= :year_min");
      replacements.year_min = parseInt(year_min, 10);
    }
    if (year_max) {
      whereClauses.push("car.year <= :year_max");
      replacements.year_max = parseInt(year_max, 10);
    }
    if (mileage_min) {
      whereClauses.push("lot.odometer_mi >= :mileage_min");
      replacements.mileage_min = parseInt(mileage_min, 10);
    }
    if (mileage_max) {
      whereClauses.push("lot.odometer_mi <= :mileage_max");
      replacements.mileage_max = parseInt(mileage_max, 10);
    }
    if (postal_code && !latitude && !longitude) {
      const coordinates = await getLatLonByPostalCode(postal_code);
      if (coordinates) {
        latitude = coordinates.lat;
        longitude = coordinates.lon;
      }
    }

    const hasCoordinates = latitude && longitude;
    replacements.latitude = hasCoordinates ? parseFloat(latitude) : 0;
    replacements.longitude = hasCoordinates ? parseFloat(longitude) : 0;

    if (hasCoordinates) {
      const radiusInKm = parseFloat(radius) || 50;
      whereClauses.push(`
        (6371 * acos(
          cos(radians(:latitude)) *
          cos(radians(lot.latitude)) *
          cos(radians(lot.longitude) - radians(:longitude)) +
          sin(radians(:latitude)) *
          sin(radians(lot.latitude))
        )) <= :radius
      `);
      replacements.radius = radiusInKm;
    }

    const whereQuery = whereClauses.length ? `WHERE ${whereClauses.join(" AND ")}` : "";

    const query = `
      SELECT 
        car.id AS car_id, car.vin, car.year, car.title, 
        car.manufacturer_id, car.model_id, car.generation_id,
        car.body_type, car.color, car.engine_id, car.transmission, 
        car.drive_wheel, car.vehicle_type, car.fuel, car.cylinders, 
        car.views, car.sitemap_id, car.created_at, car.updated_at, 
        car.download_specs_at, car.processed_specs_at, car.has_images, 
        car.has_bid, car.has_buy_now, car.is_hidden, car.is_archived, 
        car.engine_volume,
        man.name AS manufacturer, model.name AS model, 
        lot.id AS lot_id, lot.buy_now_price, lot.estimate_repair_price, lot.sale_date, lot.actual_cash_value, lot.bid, lot.odometer_mi AS mileage, 
        lot.latitude, lot.longitude, lot.seller_id, 
        location.name AS location, 
        city.name AS city, state.name AS state, lot.postal_code,
        seller.name AS seller_name,
        eng.id AS engine_id, eng.name AS eng_name,
        COALESCE(JSON_AGG(DISTINCT img.images::TEXT) FILTER (WHERE img.images IS NOT NULL), '[]') AS images,
        (6371 * acos(
          cos(radians(:latitude)) *
          cos(radians(lot.latitude)) *
          cos(radians(lot.longitude) - radians(:longitude)) +
          sin(radians(:latitude)) *
          sin(radians(lot.latitude))
        )) AS distance
      FROM cars car
      JOIN lots lot ON car.id = lot.car_id
      JOIN manufacturers man ON man.id = car.manufacturer_id
      JOIN models model ON car.model_id = model.id
      JOIN sellers seller ON lot.seller_id = seller.id
      JOIN locations location ON lot.location_id = location.id
      JOIN cities city ON lot.city_id = city.id
      JOIN states state ON lot.state_id = state.id
      JOIN engines eng ON car.engine_id = eng.id
      LEFT JOIN images img ON car.id = img.car_id
      ${whereQuery}
      GROUP BY car.id, man.name, model.name, lot.id, lot.latitude, lot.longitude,
              location.name, city.name, state.name, lot.postal_code, seller.name, eng.id
      LIMIT :limit OFFSET :offset;
    `;

    const carLots = await sequelize.query(query, {
      replacements,
      type: sequelize.QueryTypes.SELECT,
    });

    return res.status(200).json({ page, limit, data: carLots });
  } catch (error) {
    console.error("Error fetching salvage car data:", error);
    return res.status(500).json({ error: "Internal Server Error" });
  }
};

//working code for salvage car list end here-------------------

// const salvageCarListbyPost = async (req, res) => {
//   try {
//     const page = parseInt(req.query.page, 10) || 1;
//     const limit = parseInt(req.query.limit, 10) || 20;
//     const offset = (page - 1) * limit;

//     let { model, manufacturer, year, postal_code, mileage_min, mileage_max, year_min, year_max, latitude, longitude, radius, title } = req.query;

//     let whereClauses = ["car.has_bid = true"];
//     let replacements = { limit, offset };

//     if (manufacturer) {
//       whereClauses.push("man.name ILIKE :manufacturer");
//       replacements.manufacturer = `%${manufacturer}%`;
//     }
//     if (model) {
//       whereClauses.push("model.name ILIKE :model");
//       replacements.model = `%${model}%`;
//     }
//     if (title) {
//       whereClauses.push("car.title ILIKE :title");
//       replacements.title = `%${title}%`;
//     }
//     if (year) {
//       whereClauses.push("car.year = :year");
//       replacements.year = parseInt(year, 10);
//     }
//     if (year_min) {
//       whereClauses.push("car.year >= :year_min");
//       replacements.year_min = parseInt(year_min, 10);
//     }
//     if (year_max) {
//       whereClauses.push("car.year <= :year_max");
//       replacements.year_max = parseInt(year_max, 10);
//     }
//     if (mileage_min) {
//       whereClauses.push("lot.odometer_mi >= :mileage_min");
//       replacements.mileage_min = parseInt(mileage_min, 10);
//     }
//     if (mileage_max) {
//       whereClauses.push("lot.odometer_mi <= :mileage_max");
//       replacements.mileage_max = parseInt(mileage_max, 10);
//     }
//     if (postal_code && !latitude && !longitude) {
//       const coordinates = await getLatLonByPostalCode(postal_code);
//       if (coordinates) {
//         latitude = coordinates.lat;
//         longitude = coordinates.lon;
//       }
//     }

//     const hasCoordinates = latitude && longitude;
//     replacements.latitude = hasCoordinates ? parseFloat(latitude) : 0;
//     replacements.longitude = hasCoordinates ? parseFloat(longitude) : 0;

//     if (hasCoordinates) {
//       const radiusInKm = parseFloat(radius) || 50;
//       whereClauses.push(`
//         (6371 * acos(
//           cos(radians(:latitude)) *
//           cos(radians(lot.latitude)) *
//           cos(radians(lot.longitude) - radians(:longitude)) +
//           sin(radians(:latitude)) *
//           sin(radians(lot.latitude))
//         )) <= :radius
//       `);
//       replacements.radius = radiusInKm;
//     }

//     const whereQuery = whereClauses.length ? `WHERE ${whereClauses.join(" AND ")}` : "";

//     const query = `
//       SELECT 
//         car.id AS car_id, car.vin, car.year, car.title, 
//         car.manufacturer_id, car.model_id, car.generation_id,
//         car.body_type, car.color, car.engine_id, car.transmission, 
//         car.drive_wheel, car.vehicle_type, car.fuel, car.cylinders, 
//         car.views, car.sitemap_id, car.created_at, car.updated_at, 
//         car.download_specs_at, car.processed_specs_at, car.has_images, 
//         car.has_bid, car.has_buy_now, car.is_hidden, car.is_archived, 
//         car.engine_volume,
//         man.name AS manufacturer, model.name AS model, 
//         lot.id AS lot_id, lot.buy_now_price, lot.estimate_repair_price, lot.sale_date, lot.actual_cash_value, lot.bid, lot.odometer_mi AS mileage, 
//         lot.latitude, lot.longitude, lot.seller_id, 
//         location.name AS location, 
//         city.name AS city, state.name AS state, lot.postal_code,
//         seller.name AS seller_name,
//         eng.id AS engine_id, eng.name AS eng_name,
//         COALESCE(JSON_AGG(DISTINCT img.images::TEXT) FILTER (WHERE img.images IS NOT NULL), '[]') AS images,
//         (6371 * acos(
//           cos(radians(:latitude)) *
//           cos(radians(lot.latitude)) *
//           cos(radians(lot.longitude) - radians(:longitude)) +
//           sin(radians(:latitude)) *
//           sin(radians(lot.latitude))
//         )) AS distance,
//         CASE
//           WHEN lot.bid IS NULL AND lot.buy_now_price IS NOT NULL AND lot.buy_now_price > 0 THEN
//             lot.buy_now_price * 0.88
//           ELSE NULL
//         END AS estimated_bid
//       FROM cars car
//       JOIN lots lot ON car.id = lot.car_id
//       JOIN manufacturers man ON man.id = car.manufacturer_id
//       JOIN models model ON car.model_id = model.id
//       JOIN sellers seller ON lot.seller_id = seller.id
//       JOIN locations location ON lot.location_id = location.id
//       JOIN cities city ON lot.city_id = city.id
//       JOIN states state ON lot.state_id = state.id
//       JOIN engines eng ON car.engine_id = eng.id
//       LEFT JOIN images img ON car.id = img.car_id
//       ${whereQuery}
//       GROUP BY car.id, man.name, model.name, lot.id, lot.latitude, lot.longitude,
//               location.name, city.name, state.name, lot.postal_code, seller.name, eng.id
//       LIMIT :limit OFFSET :offset;
//     `;

//     const carLots = await sequelize.query(query, {
//       replacements,
//       type: sequelize.QueryTypes.SELECT,
//     });

//     return res.status(200).json({ page, limit, data: carLots });
//   } catch (error) {
//     console.error("Error fetching salvage car data:", error);
//     return res.status(500).json({ error: "Internal Server Error" });
//   }
// };



// --------------------------------------


const marketingValueCarListbypostforradius = async (req, res) => {
  try {
    const page = parseInt(req.query.page, 10) || 1;
    const limit = parseInt(req.query.limit, 10) || 20;
    const offset = (page - 1) * limit;

    let {
      model,
      manufacturer,
      year,
      postal_code,
      year_min,
      year_max,
      latitude,
      longitude,
      radius,
      mileage_min,
      mileage_max
    } = req.query;

    let whereClauses = ["car.has_bid = false"];
    let replacements = { limit, offset };

    if (manufacturer) {
      whereClauses.push("man.name ILIKE :manufacturer");
      replacements.manufacturer = `%${manufacturer}%`;
    }
    if (model) {
      whereClauses.push("model.name ILIKE :model");
      replacements.model = `%${model}%`;
    }    
    if (year) {
      whereClauses.push("car.year = :year");
      replacements.year = parseInt(year, 10);
    }
    if (year_min) {
      whereClauses.push("car.year >= :year_min");
      replacements.year_min = parseInt(year_min, 10);
    }
    if (year_max) {
      whereClauses.push("car.year <= :year_max");
      replacements.year_max = parseInt(year_max, 10);
    }
    if (mileage_min) {
      whereClauses.push("lot.odometer_mi >= :mileage_min");
      replacements.mileage_min = parseInt(mileage_min, 10);
    }
    if (mileage_max) {
      whereClauses.push("lot.odometer_mi <= :mileage_max");
      replacements.mileage_max = parseInt(mileage_max, 10);
    }
    if (postal_code && !latitude && !longitude) {
      const coordinates = await getLatLonByPostalCode(postal_code);
      if (coordinates) {
        latitude = coordinates.lat;
        longitude = coordinates.lon;
      }
    }

    const hasCoordinates = latitude && longitude;
    replacements.latitude = hasCoordinates ? parseFloat(latitude) : 0;
    replacements.longitude = hasCoordinates ? parseFloat(longitude) : 0;

    if (hasCoordinates) {
      const radiusInKm = parseFloat(radius) || 50;
      whereClauses.push(`
        (6371 * acos(
          cos(radians(:latitude)) *
          cos(radians(lot.latitude)) *
          cos(radians(lot.longitude) - radians(:longitude)) +
          sin(radians(:latitude)) *
          sin(radians(lot.latitude))
        )) <= :radius
      `);
      replacements.radius = radiusInKm;
    }

    const whereQuery =
      whereClauses.length > 0 ? `WHERE ${whereClauses.join(" AND ")}` : "";

    const orderBy = hasCoordinates ? "distance" : "car.id";

    const query = `
     SELECT 
    car.id AS car_id, car.vin, car.year, car.title,
    car.manufacturer_id, car.model_id, car.generation_id,
    car.body_type, car.color, car.engine_id, car.transmission,
    car.drive_wheel, car.vehicle_type, car.fuel, car.cylinders,
    car.views, car.sitemap_id, car.created_at, car.updated_at,
    car.download_specs_at, car.processed_specs_at, car.has_images,
    car.has_bid, car.has_buy_now, car.is_hidden, car.is_archived,
    car.engine_volume, engine.name AS engine_name,
    man.name AS manufacturer, model.name AS model,
    lot.id AS lot_id, lot.actual_cash_value, lot.buy_now_price, lot.bid, lot.odometer_km, lot.odometer_mi,
    lot.latitude, lot.longitude, lot.seller_id,
    location.name AS location,
    city.name AS city, state.name AS state, lot.postal_code,
    seller.name AS seller_name,
    COALESCE(JSON_AGG(DISTINCT img.images::TEXT) FILTER (WHERE img.images IS NOT NULL), '[]') AS images,
    (6371 * acos(
      cos(radians(:latitude)) *
      cos(radians(lot.latitude)) *
      cos(radians(lot.longitude) - radians(:longitude)) +
      sin(radians(:latitude)) *
      sin(radians(lot.latitude))
    )) AS distance
FROM cars car
JOIN lots lot ON car.id = lot.car_id
JOIN manufacturers man ON man.id = car.manufacturer_id
JOIN models model ON car.model_id = model.id
JOIN sellers seller ON lot.seller_id = seller.id
JOIN locations location ON lot.location_id = location.id
JOIN cities city ON lot.city_id = city.id
JOIN states state ON lot.state_id = state.id
JOIN engines engine ON car.engine_id = engine.id
LEFT JOIN images img ON car.id = img.car_id
${whereQuery}
GROUP BY car.id, man.name, model.name, lot.id, lot.latitude, lot.longitude,
         location.name, city.name, state.name, lot.postal_code, seller.name, engine.name
ORDER BY ${orderBy}
LIMIT :limit OFFSET :offset;
    `;

    const carLots = await sequelize.query(query, {
      replacements,
      type: sequelize.QueryTypes.SELECT,
    });

    return res.status(200).json({ page, limit, data: carLots });
  } catch (error) {
    console.error("Error fetching car-lot data:", error);
    res.status(500).json({ error: "Internal Server Error" });
  }
};

const carFilteraton = async (req, res, next) => {
  try {
    const { year_min, make, model, city, state, exterior_color, page } =
      req.body;
    const api = `https://auto.dev/api/listings?apikey=${process.env.AUTO_DEV_KEY}&year_min=${year_min}&make=${make}&model=${model}&trim[]=Base&trim[]=SH-AWD&city=${city}&state=${state}&page=${page}`;
    let options = {
      method: "GET",
      url: api,
    };
    const result = await axios(options);
    return res.status(200).json({
      message: "Fetch Successfully",
      result: result.data,
    });
  } catch (err) {
    next(err);
  }
};

const auction = async (req, res, next) => {
  try {
    const { vin } = req.params;
    const api = `https://api.vehicledatabases.com/auction/${vin}`;
    let option = {
      method: "GET",
      url: api,
      headers: {
        "x-authKey": `${process.env.VEHICLE_DB}`,
      },
    };
    let result = await axios(option);
    return res.status(200).json({
      message: "Fetch Successfully",
      result: result.data,
    });
  } catch (err) {
    return res.status(200).json({
      message: "Auction History on the basis of Vin Code",
      result: [],
      error: err,
    });
  }
};

const premiumVinDecode = async (req, res, next) => {
  try {
    const { vin } = req.params;
    const api = `https://api.vehicledatabases.com/premium/vin-decode/${vin}`;
    let option = {
      method: "GET",
      url: api,
      headers: {
        "x-authKey": `${process.env.VEHICLE_DB}`,
      },
    };
    const result = await axios(option);
    return res.status(200).json({
      message: "Fetch Successfully",
      result: result.data,
    });
  } catch (err) {
    console.log(err)
    next(err);
  }
};

const marketValuebyVin = async (req, res, next) => {
  try {
    const { vin} = req.query;
    const api = `https://api.vehicledatabases.com/market-value/v2/${vin}`;
    let option = {
      method: "GET",
      url: api,
      headers: {
        "x-authKey": `2e9b54370c164ed388adc4ddac50fa9f`,
      },
    };
    const { data } = await axios(option);
    return res.status(200).json({
      message: "Fetch Successfully",
      result: data,
      vin
    });
  } catch (err) {
    return res.status(500).json({
      statusCode:500,
      message:err.message
    })
  }
};

const marketValuebyYearAndModel = async (req, res, next) => {
  try {
    const { year, make, model, mileage_value, state } = req.query;
    const api = `https://api.vehicledatabases.com/market-value/v2/ymm/${year}/${make}/${model}?state=${state}&mileage=${mileage_value}`;
    let option = {
      method: "GET",
      url: api,
      headers: {
        "x-authKey": `${process.env.VEHICLE_DB}`,
      },
    };
    const { data } = await axios(option);
    return res.status(200).json({
      message: "Fetch Successfully",
      result: data,
    });
  } catch (err) {
    next(err);
  }
};

const vehicleRepair = async (req, res, next) => {
  try {
    const { year, make, model } = req.query;
    const api = `https://api.vehicledatabases.com/vehicle-repairs/${year}/${make}/${model}`;
    let option = {
      method: "GET",
      url: api,
      headers: {
        "x-authKey": `${process.env.VEHICLE_DB}`,
      },
    };
    const { data } = await axios(option);
    return res.status(200).json({
      message: "Fetch Successfully",
      result: data,
    });
  } catch (err) {
    next(err);
  }
};

const vehicleWarranty = async (req, res, next) => {
  try {
    const { year, make, model } = req.query;
    const api = `https://api.vehicledatabases.com/vehicle-warranty/${year}/${make}/${model}$`;
    let option = {
      method: "GET",
      url: api,
      headers: {
        "x-authKey": `${process.env.VEHICLE_DB}`,
      },
    };
    const { data } = await axios(option);
    return res.status(200).json({
      message: "Fetch Successfully",
      result: data,
    });
  } catch (err) {
    next(err);
  }
};

const marketValue = async (req, res, next) => {
  try {
    const { vin, state, mileage } = req.params;

    const response = await axios.get(
      `https://api.vehicledatabases.com/market-value/v2/${vin}`,
      {
        params: {
          state: state,
          mileage: mileage,
        },
        headers: {
          "x-AuthKey": `${process.env.VEHICLE_DB}`,
        },
      }
    );
    return res.json(response.data);
  } catch (error) {
    console.error(error);
    res
      .status(500)
      .json({ error: "An error occurred while fetching the market value." });
  }
};

const generateReport = async (req, res, next) => {
  try {
    const data = req.body;

    const htmlTemplate = `
      <html>
      <head>
        <style>
          body {
            font-family: Arial, sans-serif;
            margin: 20px;
            color: #333;
          }
          h1 {
            color: #4CAF50;
          }
          table {
            width: 100%;
            border-collapse: collapse;
            margin-bottom: 20px;
          }
          table, th, td {
            border: 1px solid #ddd;
            padding: 8px;
          }
          th {
            background-color: #f2f2f2;
          }
          .section {
            margin-bottom: 40px;
          }
          .section-title {
            font-size: 20px;
            color: #4CAF50;
            margin-bottom: 10px;
          }
          .market-value-table {
            width: 100%;
            border-collapse: collapse;
          }
          .market-value-table th {
            background-color: #f2f2f2;
          }
        </style>
      </head>
      <body>
        <h1>Vehicle Report</h1>
        
        <div class="section">
          <div class="section-title">Vehicle Details</div>
          <table>
            <tr><th>VIN</th><td>${data.intro.vin}</td></tr>
            <tr><th>Make</th><td>${data.basic.make}</td></tr>
            <tr><th>Model</th><td>${data.basic.model}</td></tr>
            <tr><th>Year</th><td>${data.basic.year}</td></tr>
            <tr><th>Trim</th><td>${data.basic.trim}</td></tr>
          </table>
        </div>

        <div class="section">
          <div class="section-title">Market Value</div>
          <table class="market-value-table">
            <tr>
              <th>Condition</th>
              <th>Trade-In</th>
              <th>Private Party</th>
              <th>Dealer Retail</th>
            </tr>
            ${
              Array.isArray(data.market_value.market_value_data) &&
              data.market_value.market_value_data[0] &&
              Array.isArray(
                data.market_value.market_value_data[0]["market value"]
              )
                ? data.market_value.market_value_data[0]["market value"]
                    .map(
                      (mv) => `
                <00000000000tr>
                  <td>${mv.Condition}</td>
                  <td>${mv["Trade-In"]}</td>
                  <td>${mv["Private Party"]}</td>
                  <td>${mv["Dealer Retail"]}</td>
                </tr>
              `
                    )
                    .join("")
                : '<tr><td colspan="4">No market value data available</td></tr>'
            }
          </table>
        </div>

        <div class="section">
          <div class="section-title">Engine Specifications</div>
          <table>
            <tr><th>Engine</th><td>${data.engine.name}</td></tr>
            <tr><th>Cylinder</th><td>${data.engine.cylinder}</td></tr>
            <tr><th>Size</th><td>${data.engine.size} L</td></tr>
            <tr><th>Horsepower</th><td>${data.engine.horsepower}</td></tr>
            <tr><th>Torque</th><td>${data.engine.torque} lb-ft</td></tr>
          </table>
        </div>

        <div class="section">
          <div class="section-title">Transmission</div>
          <table>
            <tr><th>Type</th><td>${data.transmission.transmissionType}</td></tr>
            <tr><th>Number of Speeds</th><td>${
              data.transmission.numberOfSpeeds
            }</td></tr>
          </table>
        </div>

        <div class="section">
          <div class="section-title">Fuel Efficiency</div>
          <table>
            <tr><th>Highway MPG</th><td>${data.mpg.highway}</td></tr>
            <tr><th>City MPG</th><td>${data.mpg.city}</td></tr>
          </table>
        </div>
      </body>
      </html>
    `;

    // Launch Playwright and generate PDF
    const browser = await chromium.launch();
    const page = await browser.newPage();
    await page.setContent(htmlTemplate);
    const buffer = await page.pdf({ format: "A4" });

    await browser.close();

    res.setHeader("Content-Type", "application/pdf");
    res.setHeader(
      "Content-Disposition",
      'attachment; filename="vehicle_report.pdf"'
    );
    res.setHeader("Content-Length", buffer.length);

    res.send(buffer);
  } catch (err) {
    next(err);
  }
};

//existing code for generate market value price:----------
// const generateFreetrialPdf = async (req, res, next) => {
//   try {
//     const data = req.body;
//     const htmlTemplate = `
//       <html>
//       <head>
//         <style>
//           body {
//             font-family: 'Helvetica Neue', Arial, sans-serif;
//             margin: 0;
//             padding: 40px;
//             background-color: #f4f4f4;
//             color: #333;
//             line-height: 1.6;
//           }
//           h1 {
//             font-size: 28px;
//             color: #222;
//             border-bottom: 2px solid #333;
//             padding-bottom: 10px;
//             margin-bottom: 20px;
//           }
//           h2 {
//             font-size: 22px;
//             color: #444;
//             border-left: 4px solid #00aaff;
//             padding-left: 10px;
//             margin-bottom: 10px;
//           }
//           .listing {
//             background-color: #fff;
//             padding: 20px;
//             margin-bottom: 30px;
//             box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
//             border-radius: 5px;
//           }
//           .info {
//             margin-bottom: 8px;
//             display: flex;
//             justify-content: space-between;
//           }
//           .info label {
//             font-weight: bold;
//             color: #555;
//             flex: 1;
//           }
//           .info span {
//             flex: 2;
//             text-align: right;
//             color: #333;
//           }
//           .car-images img {
//             max-width: 100%;
//             height: auto;
//             border: 1px solid #ddd;
//             padding: 5px;
//             background-color: #f9f9f9;
//             margin-top: 10px;
//             border-radius: 4px;
//           }
//           table {
//             width: 100%;
//             border-collapse: collapse;
//             margin-bottom: 20px;
//           }
//           table, th, td {
//             border: 1px solid #ddd;
//             padding: 8px;
//           }
//           th {
//             background-color: #f2f2f2;
//           }
//           .section {
//             margin-bottom: 40px;
//           }
//           .section-title {
//             font-size: 20px;
//             color: #00aaff;
//             margin-bottom: 10px;
//           }
//         </style>
//       </head>
//       <body>
//         <h1>Car Report</h1>
//         <div class="section">
//           <div class="section-title">Information</div>
//           <table>
//             <tr><th>VIN</th><td>${data.marketValueList.vin}</td></tr>
//             <tr><th>Model Year</th><td>${data.marketValueList.modelYear}</td></tr>
//             <tr><th>Make</th><td>${data.marketValueList.make}</td></tr>
//             <tr><th>Model</th><td>${data.marketValueList.model}</td></tr>
//             <tr><th>Trim</th><td>${data.marketValueList.trim}</td></tr>
//             <tr><th>Paint Code</th><td>${data.marketValueList.paintCode}</td></tr>
//             <tr><th>Mileage</th><td>${data.marketValueList.mileage}</td></tr>
//             <tr><th>City</th><td>${data.marketValueList.city}</td></tr>
//             <tr><th>Condition</th><td>${data.marketValueList.condition}</td></tr>
//             <tr><th>Primary Damage</th><td>${data.marketValueList.primaryDamage}</td></tr>
//             <tr><th>Drivable Status</th><td>${data.marketValueList.drivableStatus}</td></tr>
//             <tr><th>Repair Costs</th><td>${data.marketValueList.repairCosts}</td></tr>
//             <tr><th>ACV</th><td>${data.marketValueList.acv}</td></tr>
//             <tr><th>TLV</th><td>${data.marketValueList.tlv}</td></tr>
//             <tr><th>Cost of Repair</th><td>${data.marketValueList.costOfRepair}</td></tr>
//             <tr><th>Total Loss Status</th><td>${data.marketValueList.totalLossStatus}</td></tr>
//           </table>
//         </div>
//         ${data.slectedCars
//           .map(
//             (car, index) => `
//           <div class="section listing">
//             <h2>${car.carDetail.year} ${car.carDetail.make} ${car.carDetail.model}</h2>
//             <div class="info"><label>VIN:</label> <span>${car.carDetail.vin}</span></div>
//             <div class="info"><label>Year:</label> <span>${car.carDetail.year}</span></div>
//             <div class="info"><label>Make:</label> <span>${car.carDetail.make}</span></div>
//             <div class="info"><label>Model:</label> <span>${car.carDetail.model}</span></div>
//             <div class="info"><label>Seller Name:</label> <span>${car.carDetail.trim}</span></div>
//             <div class="info"><label>Seller Name:</label> <span>${car.carDetail.mileage}</span></div>
//             <div class="info"><label>Buy Now price:</label> <span>${car.carDetail.price}</span></div>
//             <div class="info"><label>Seller Name:</label> <span>${car.carDetail.dealerName}</span></div>
//             <div class="info"><label>Address:</label> <span>${car.carDetail.dealerName}, ${car.carDetail.city}, ${car.carDetail.state}</span></div>
//           </div>
//         `
//           )
//           .join("")}
//       </body>
//       </html>
//     `;

//     const browser = await chromium.launch();
//     const page = await browser.newPage();
//     await page.setContent(htmlTemplate);
//     const buffer = await page.pdf({ format: "A4" });

//     await browser.close();

//     res.set({
//       "Content-Type": "application/pdf",
//       "Content-Disposition": 'attachment; filename="car_report.pdf"',
//       "Content-Length": buffer.length,
//     });

//     res.send(buffer);
//   } catch (err) {
//     console.error("Error generating PDF:", err);
//     next(err);
//   }
// };

const generateFreetrialPdf = async (req, res, next) => {
  try {
    const data = req.body;
    const htmlTemplate = `
      <html>
      <head>
        <style>
          body {
            font-family: 'Helvetica Neue', Arial, sans-serif;
            margin: 0;
            padding: 40px;
            background-color: #f4f4f4;
            color: #333;
            line-height: 1.6;
          }
          h1 {
            font-size: 28px;
            color: #222;
            border-bottom: 2px solid #333;
            padding-bottom: 10px;
            margin-bottom: 20px;
          }
          h2 {
            font-size: 22px;
            color: #444;
            border-left: 4px solid #00aaff;
            padding-left: 10px;
            margin-bottom: 10px;
          }
          .listing {
            background-color: #fff;
            padding: 20px;
            margin-bottom: 30px;
            box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
            border-radius: 5px;
          }
          .info {
            margin-bottom: 8px;
            display: flex;
            justify-content: space-between;
          }
          .info label {
            font-weight: bold;
            color: #555;
            flex: 1;
          }
          .info span {
            flex: 2;
            text-align: right;
            color: #333;
          }
          .car-images img {
            max-width: 100%;
            height: auto;
            border: 1px solid #ddd;
            padding: 5px;
            background-color: #f9f9f9;
            margin-top: 10px;
            border-radius: 4px;
          }
          table {
            width: 100%;
            border-collapse: collapse;
            margin-bottom: 20px;
          }
          table, th, td {
            border: 1px solid #ddd;
            padding: 8px;
          }
          th {
            background-color: #f2f2f2;
          }
          .section {
            margin-bottom: 40px;
          }
          .section-title {
            font-size: 20px;
            color: #00aaff;
            margin-bottom: 10px;
          }
          .page-break {
            page-break-before: always;
          }
        </style>
      </head>
      <body>
        <h1>Car Report</h1>
        <div class="section">
          <div class="section-title">Information</div>
          <table>
            <tr><th>VIN</th><td>${data.marketValueList.vin}</td></tr>
            <tr><th>Model Year</th><td>${data.marketValueList.modelYear}</td></tr>
            <tr><th>Make</th><td>${data.marketValueList.make}</td></tr>
            <tr><th>Model</th><td>${data.marketValueList.model}</td></tr>
            <tr><th>Trim</th><td>${data.marketValueList.trim}</td></tr>
            <tr><th>Paint Code</th><td>${data.marketValueList.paintCode}</td></tr>
            <tr><th>Mileage</th><td>${data.marketValueList.mileage}</td></tr>
            <tr><th>City</th><td>${data.marketValueList.city}</td></tr>
            <tr><th>Condition</th><td>${data.marketValueList.condition}</td></tr>
            <tr><th>Primary Damage</th><td>${data.marketValueList.primaryDamage}</td></tr>
            <tr><th>Drivable Status</th><td>${data.marketValueList.drivableStatus}</td></tr>
            <tr><th>Repair Costs</th><td>${data.marketValueList.repairCosts}</td></tr>
            <tr><th>ACV</th><td>${data.marketValueList.acv}</td></tr>
            <tr><th>TLV</th><td>${data.marketValueList.tlv}</td></tr>
            <tr><th>Cost of Repair</th><td>${data.marketValueList.costOfRepair}</td></tr>
            <tr><th>Total Loss Status</th><td>${data.marketValueList.totalLossStatus}</td></tr>
          </table>
        </div>
        ${data.slectedCars
          .map(
            (car, index) => `
          <div class="page-break"></div>
          <div class="section listing">
            <h2>${car.carDetail.year} ${car.carDetail.make} ${car.carDetail.model}</h2>
            <div class="info"><label>VIN:</label> <span>${car.carDetail.vin}</span></div>
            <div class="info"><label>Year:</label> <span>${car.carDetail.year}</span></div>
            <div class="info"><label>Make:</label> <span>${car.carDetail.make}</span></div>
            <div class="info"><label>Model:</label> <span>${car.carDetail.model}</span></div>
            <div class="info"><label>Seller Name:</label> <span>${car.carDetail.trim}</span></div>
            <div class="info"><label>Seller Name:</label> <span>${car.carDetail.mileage}</span></div>
            <div class="info"><label>Buy Now price:</label> <span>${car.carDetail.price}</span></div>
            <div class="info"><label>Seller Name:</label> <span>${car.carDetail.dealerName}</span></div>
            <div class="info"><label>Address:</label> <span>${car.carDetail.dealerName}, ${car.carDetail.city}, ${car.carDetail.state}</span></div>
          </div>
        `
          )
          .join("")}
      </body>
      </html>
    `;

    const browser = await chromium.launch();
    const page = await browser.newPage();
    await page.setContent(htmlTemplate);
    const buffer = await page.pdf({ format: "A4" });

    await browser.close();

    res.set({
      "Content-Type": "application/pdf",
      "Content-Disposition": 'attachment; filename="car_report.pdf"',
      "Content-Length": buffer.length,
    });

    res.send(buffer);
  } catch (err) {
    console.error("Error generating PDF:", err);
    next(err);
  }
};


//code for market value 


const generateSalvagePdf = async (req, res, next) => {
  try {
    const data = req.body;

    if (!Array.isArray(data) || data.length === 0) {
      return res.status(400).json({
        error: "Invalid data format. Expected an array of car objects.",
      });
    }

    const template = `
    <!DOCTYPE html>
    <html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Salvage Car Report</title>
        <style>
            body {
                font-family: 'Helvetica Neue', Arial, sans-serif;
                margin: 0;
                padding: 40px;
                background-color: #f4f4f4;
                color: #333;
                line-height: 1.6;
            }
            h1 {
                font-size: 28px;
                color: #222;
                border-bottom: 2px solid #333;
                padding-bottom: 10px;
                margin-bottom: 20px;
            }
            h2 {
                font-size: 22px;
                color: #444;
                border-left: 4px solid #00aaff;
                padding-left: 10px;
                margin-bottom: 10px;
            }
            .listing {
                background-color: #fff;
                padding: 20px;
                margin-bottom: 30px;
                box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
                border-radius: 5px;
            }
            .info {
                margin-bottom: 8px;
                display: flex;
                justify-content: space-between;
            }
            .info label {
                font-weight: bold;
                color: #555;
                flex: 1;
            }
            .info span {
                flex: 2;
                text-align: right;
                color: #333;
            }
            .dealer-info {
                background-color: #fafafa;
                padding: 20px;
                border: 1px solid #eaeaea;
                border-radius: 5px;
            }
            .dealer-info h2 {
                font-size: 20px;
                margin-bottom: 10px;
                color: #333;
            }
            .dealer-info p {
                margin: 5px 0;
                font-size: 14px;
                color: #555;
            }
            .car-images img {
                max-width: 100%;
                height: auto;
                border: 1px solid #ddd;
                padding: 5px;
                background-color: #f9f9f9;
                margin-top: 10px;
                border-radius: 4px;
            }
        </style>
    </head>
    <body>
      <h1>Salvage Car Report</h1>
      
      ${data
        .map((car) => {
          const roughCondition = car.marketValues?.["market value"]?.find(
            (condition) => condition.Condition === "Rough"
          );
          let auctionPriceArray = [];
          let displayPrice;

          if (Array.isArray(car.auctionData) && car.auctionData.length > 0) {
            auctionPriceArray = car.auctionData.map((item) => {
              const priceString = item.data?.price || "0";
              return parseFloat(priceString.replace(/[$,]/g, ""));
            });
          } else if (
            typeof car.auctionData === "object" &&
            car.auctionData.data
          ) {
            auctionPriceArray = car.auctionData.data.map((item) => {
              const priceString = item.price || "0";
              return parseFloat(priceString.replace(/[$,]/g, ""));
            });
          }
          const validAuctionPrices = auctionPriceArray.filter(
            (price) => !isNaN(price) && price > 0
          );

          if (validAuctionPrices.length > 0) {
            displayPrice = Math.max(...validAuctionPrices).toFixed(2);
          } else {
            const privatePartyValue =
              parseFloat(roughCondition?.["Trade-In"].replace(/[$,]/g, "")) ||
              0;
            displayPrice = (
              privatePartyValue -
              privatePartyValue * 0.83
            ).toFixed(2);
          }

          return `
          <div class="listing">
            <h2>${car.heading || "N/A"}</h2>
            <div class="car-images">
              <img src="${
                car.media?.photo_links?.[0] || "https://via.placeholder.com/150"
              }" alt="Car Image" />
            </div>
            <div class="info">
              <label>VIN:</label> <span>${car.vin || "N/A"}</span>
            </div>
            <div class="info">
              <label>Year:</label> <span>${car.build?.year || "N/A"}</span>
            </div>
            <div class="info">
              <label>Make:</label> <span>${car.build?.make || "N/A"}</span>
            </div>
            <div class="info">
              <label>Model:</label> <span>${car.build?.model || "N/A"}</span>
            </div>
            <div class="info">
              <label>Trim:</label> <span>${car.build?.trim || "N/A"}</span>
            </div>
            <div class="info">
              <label>Miles:</label> <span>${car.miles || "N/A"}</span>
            </div>
            <div class="info">
              <label>Exterior Color:</label> <span>${
                car.exterior_color || "N/A"
              }</span>
            </div>
            <div class="info">
              <label>Title Type:</label> <span>${car.title_type || "N/A"}</span>
            </div>
            <div class="info">
              <label>Fuel Type:</label> <span>${
                car.build?.fuel_type || "N/A"
              }</span>
            </div>
            <div class="info">
                <label>Engine:</label> <span>${
                  car.build?.engine || "N/A"
                }</span>
            </div>
            <div class="info">
              <label>Transmission:</label> <span>${
                car.build?.transmission || "N/A"
              }</span>
            </div>
            <div class="info">
              <label>Drivetrain:</label> <span>${
                car.build?.drivetrain || "N/A"
              }</span>
            </div>
            <div class="info">
              <label>Highway MPG:</label> <span>${
                car.build?.highway_mpg || "N/A"
              }</span>
            </div>
            <div class="info">
              <label>City MPG:</label> <span>${
                car.build?.city_mpg || "N/A"
              }</span>
            </div>
            
            <div class="info">
              <label>Salvage Price:</label>
              <span>$${displayPrice}</span>
            </div>
          </div><br><br><br>
            <div class="dealer-info">
              <h2>Dealer Information</h2>
              <p><strong>Name:</strong> ${car.dealer.name || "N/A"}</p>
              <p><strong>Website:</strong> ${car.dealer.website || "N/A"}</p>
              <p><strong>Location:</strong>${car.dealer.street || "N/A"}, ${
            car.dealer.city || "N/A"
          }, ${car.dealer.state || "N/A"}, ${car.dealer.country || "N/A"}</p>
              <p><strong>Phone:</strong> ${car.dealer.phone || "N/A"}</p>
              <p><strong>Zip:</strong> ${car.dealer.zip || "N/A"}</p>
          </div>
        `;
        })
        .join("")}
    </body>
    </html>
    `;

    const browser = await chromium.launch({ headless: true });
    const page = await browser.newPage();
    await page.setContent(template);
    const buffer = await page.pdf({ format: "A4" });

    await browser.close();

    res.set({
      "Content-Type": "application/pdf",
      "Content-Disposition": 'attachment; filename="salvage_car_report.pdf"',
      "Content-Length": buffer.length,
    });

    res.send(buffer);
  } catch (err) {
    console.error("Error generating PDF:", err.message);
    next(err);
  }
};

const homePageApi = async (req, res, next) => {
  try {
    let options = {
      method: "GET",
      url: `https://auto.dev/api/vin/${req.body.vin}?`,
      headers: {
        apiKey: `${process.env.AUTO_DEV_KEY}`,
      },
    };
    const listing = await axios(options);
    const carByVin = listing.data;

    let baseUrl = `https://auto.dev/api/listings`;
    if (req.body) {
      baseUrl += `?`;
    }

    if (req.body.condition && req.body.condition !== "") {
      baseUrl += `condition=${req.body.condition}`;
    }

    if (req.body.model && req.body.model !== "") {
      const capitalizedModel =
        req.body.model.charAt(0).toUpperCase() + req.body.model.slice(1);
      baseUrl += `&model=${capitalizedModel}`;
    }

    if (req.body.mileage && req.body.mileage !== "") {
      baseUrl += `&mileage=${req.body.mileage}`;
    }

    if (req.body.modelYear && req.body.modelYear !== "") {
      baseUrl += `&year_max=${req.body.modelYear}`;
    }

    if (req.body.body_style && req.body.body_style !== "") {
      baseUrl += `&body_style=${req.body.body_style}`;
    }

    if (req.body.page && req.body.page !== "") {
      baseUrl += `&page=${req.body.page}`;
    }

    if (req.body.city && req.body.city !== "") {
      baseUrl += `&city=${req.body.city}`;
    }

    if (req.body.trimLevel && req.body.trimLevel !== "") {
      baseUrl += `&trim=${req.body.trimLevel}`;
    }

    if (req.body.make && req.body.make !== "") {
      const makeLength = req.body.make.split(" ");
      if (makeLength.length > 1) {
        let make =
          makeLength[0].charAt(0).toUpperCase() + makeLength[0].slice(1);
        let model =
          makeLength[1].charAt(0).toUpperCase() + makeLength[1].slice(1);
        baseUrl += `&make=${make}&model=${model}`;
      } else {
        const capitalizedMake =
          req.body.make.charAt(0).toUpperCase() + req.body.make.slice(1);
        baseUrl += `&make=${capitalizedMake}`;
      }
    }

    let secondApiCredentials = {
      method: "GET",
      url: baseUrl,
      headers: {
        apiKey: `${process.env.AUTO_DEV_KEY}`,
      },
    };
    const response = await axios(secondApiCredentials);
    const carListing = response.data;

    return res.status(200).json({
      message: "Car List",
      result: { carListing, carByVin },
    });
  } catch (err) {
    next(err);
  }
};

const getSalvageCarList = async (req, res) => {
  try {
    const response = await axios.get(
      "https://mc-api.marketcheck.com/v2/search/car/auction/active?api_key=PO1xvctFD5uLcQcK6TD3lOtQWXe18ZM9&title_type=salvage&rows=50"
    );

    const car = new Car(response.data);
    await car.save();

    return res.status(200).json({
      message: "Salvage Car List Saved",
      result: response.data,
    });
  } catch (error) {
    console.error(error);
    return res
      .status(500)
      .json({ message: "Error fetching and saving car list" });
  }
};

const getSalvageCar = async (req, res, next) => {
  try {
    const page = parseInt(req.query.page, 10) || 1;
    const limit = parseInt(req.query.limit, 10) || 10;
    if (page < 1)
      return res.status(400).json({ message: "Page must be greater than 0" });
    if (limit < 1)
      return res.status(400).json({ message: "Limit must be greater than 0" });

    const skip = (page - 1) * limit;

    const allCarList = await Car.find().skip(skip).limit(limit);
    const totalCount = await Car.countDocuments();
    const totalPages = Math.ceil(totalCount / limit);

    return res.status(200).json({
      message: "Salvage Car list",
      result: allCarList,
      pagination: {
        page,
        limit,
        totalCount,
        totalPages,
      },
    });
  } catch (err) {
    console.error(err);
    next(err);
  }
};

const searchSalvageCar = async (req, res) => {
  try {
    const { zip, make, model, year, mileage, trim } = req.query;

    const query = {};

    if (zip) {
      query["listings.dealer.zip"] = zip;
    }

    if (make) {
      query["listings.build.make"] = { $regex: new RegExp(make, "i") };
    }

    if (model) {
      query["listings.build.model"] = { $regex: new RegExp(model, "i") };
    }

    if (year) {
      query["listings.build.year"] = year;
    }

    if (mileage) {
      query["listings.miles"] = { $lte: parseInt(mileage, 10) };
    }

    if (trim) {
      query["listings.build.trim"] = { $regex: new RegExp(trim, "i") };
    }

    const cars = await Car.find(query);

    if (cars.length === 0) {
      return res
        .status(404)
        .json({ message: "No cars found for the provided parameters" });
    }

    const matchedCars = cars.map((car) => {
      return {
        ...car.toObject(),
        listings: car.listings.filter((listing) => {
          return (
            (!zip || listing.dealer.zip === zip) &&
            (!make || listing.build.make.match(new RegExp(make, "i"))) &&
            (!model || listing.build.model.match(new RegExp(model, "i"))) &&
            (!year || listing.build.year === parseInt(year, 10)) &&
            (!mileage || listing.miles <= parseInt(mileage, 10)) &&
            (!trim || listing.build.trim.match(new RegExp(trim, "i")))
          );
        }),
      };
    });

    return res.status(200).json({
      result: matchedCars,
      message: "Matched cars found",
    });
  } catch (error) {
    console.error(error);
    return res
      .status(500)
      .json({ message: "An error occurred while searching for cars" });
  }
};

const fetchCarStats = async (req, res) => {
  try {
    const apiKey = "5d851973431fe43240b40a761bf1dca2";
    const { from_year = 2020, to_year = 2024, body_type = 5 } = req.query;
    const response = await axios.get("https://carstat.dev/api/cars", {
      params: {
        body_type,
        from_year,
        to_year,
      },
      headers: {
        accept: "*/*",
        "x-api-key": apiKey,
      },
    });

    return res.status(200).json(response.data);
  } catch (error) {
    console.error("Error fetching car stats:", error.message);
    return res.status(error.response?.status || 500).json({
      message: "Failed to fetch car stats",
      error: error.response?.data || error.message,
    });
  }
};



async function getBasePriceForEstimateBid(req, res,next) {
  try {
    const response = await axios.get(`https://auto.dev/api/vin/${req.params.vin}`, {
      headers: {
        'apikey': 'ZrQEPSkKd2VidGVzdDE5MkBnbWFpbC5jb20='
      }
    });
    res.json(response.data);
  } catch (error) {
    return res.status(500).json({ error: error.message });
  }
}

const finalSalvageReport = async (req, res, next) => {
  try {
    const data = req.body;
    if (!Array.isArray(data) || data.length === 0) {
      return res.status(400).json({
        error: "Invalid data format. Expected an array of car objects.",
      });
    }

    const template = `
      <!DOCTYPE html>
      <html lang="en">
      <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Salvage Car Report</title>
        <style>
          body {
            font-family: 'Helvetica Neue', Arial, sans-serif;
            margin: 0;
            padding: 40px;
            background-color: #f4f4f4;
            color: #333;
            line-height: 1.6;
          }
          h1 {
            font-size: 28px;
            color: #222;
            border-bottom: 2px solid #333;
            padding-bottom: 10px;
            margin-bottom: 20px;
          }
          h2 {
            font-size: 22px;
            color: #444;
            border-left: 4px solid #00aaff;
            padding-left: 10px;
            margin-bottom: 10px;
          }
          .listing {
            background-color: #fff;
            padding: 20px;
            margin-bottom: 30px;
            box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
            border-radius: 5px;
          }
          .info {
            margin-bottom: 8px;
            display: flex;
            justify-content: space-between;
          }
          .info label {
            font-weight: bold;
            color: #555;
            flex: 1;
          }
          .info span {
            flex: 2;
            text-align: right;
            color: #333;
          }
          .car-images img {
            max-width: 100%;
            height: auto;
            border: 1px solid #ddd;
            padding: 5px;
            background-color: #f9f9f9;
            margin-top: 10px;
            border-radius: 4px;
          }
          .page-break {
            page-break-before: always;
          }
        </style>
      </head>
      <body>
        <h1>Salvage Car Report</h1>
        ${data
          .map((car) => {
            let carDetails = `
              <div class="listing">
                <h2>${car.title || "N/A"}</h2>
            `;

            for (const key in car) {
              if (
                typeof car[key] !== "object" &&
                key !== "media" &&
                key !== "latitude" &&
                key !== "longitude" &&
                key !== "is_archived" &&
                key !== "seller_id" &&
                key !== "has_bid" &&
                key !== "has_images" &&
                key !== "processed_specs_at" &&
                key !== "manufacturer_id" &&
                key !== "model_id" &&
                key !== "generation_id" &&
                key !== "body_type" &&
                key !== "color" &&
                key !== "engine_id" &&
                key !== "views" &&
                key !== "sitemap_id" &&
                key !== "created_at" &&
                key !== "updated_at" &&
                key !== "download_specs_at" &&
                key !== "engine_volume" &&
                key !== "lot_id"&&
                key !== "is_hidden"&&
                key !== "transmission"&&
                key !== "vehicle_type"&&
                key !== "car_id"&&
                key !== "has_buy_now"&&
                key !== "distance"&&
                key !== "fuel"&&
                key !== "drive_wheel"
              ) {
                carDetails += `<div class="info"><label>${key}:</label> <span>${
                  key === "sale_date" ? car[key].split("T")[0] : (car[key] || "N/A")
                }</span></div>`;
              }
            }

            const address = `${car.location || ""}, ${car.city || ""}, ${
              car.state || ""
            }, ${car.postal_code || ""}`;
            carDetails += `<div class="info"><label>address:</label> <span>${address}</span></div>`;

            carDetails += `</div><div class="page-break"></div>`;
            return carDetails;
          })
          .join("")}
      </body>
      </html>
    `;


    const browser = await chromium.launch({ headless: true });
    const page = await browser.newPage();
    await page.setContent(template);
    const buffer = await page.pdf({ format: "A4" });

    await browser.close();

    res.set({
      "Content-Type": "application/pdf",
      "Content-Disposition": 'attachment; filename="salvage_car_report.pdf"',
      "Content-Length": buffer.length,
    });

    res.send(buffer);
  } catch (err) {
    console.error("Error generating PDF:", err.message);
    next(err);
  }
};


module.exports = {
  carMarketValue,
  carinfoByVin,
  carListing,
  saleHistory,
  carFilteraton,
  auction,
  premiumVinDecode,
  marketValuebyVin,
  marketValuebyYearAndModel,
  vehicleRepair,
  vehicleWarranty,
  premiumPlusVinDecode,
  marketValue,
  generateReport,
  generateFreetrialPdf,
  homePageApi,
  getSalvageCarList,
  generateSalvagePdf,
  searchSalvageCar,
  getSalvageCar,
  salvageCarListbyPost,
  finalSalvageReport,
  fetchCarStats,
  marketingValueCarListbypostforradius,
  getBasePriceForEstimateBid
};
