const mongoose = require('mongoose');

const mediaSchema = new mongoose.Schema({
  photo_links: [String],
});

const dealerSchema = new mongoose.Schema({
  id: Number,
  website: String,
  name: String,
  dealer_type: String,
  street: String,
  city: String,
  state: String,
  country: String,
  latitude: String,
  longitude: String,
  zip: String,
  msa_code: String,
  phone: String,
});

const buildSchema = new mongoose.Schema({
  year: Number,
  make: String,
  model: String,
  trim: String,
  body_type: String,
  vehicle_type: String,
  transmission: String,
  drivetrain: String,
  fuel_type: String,
  engine: String,
  engine_size: Number,
  engine_block: String,
  doors: Number,
  cylinders: Number,
  made_in: String,
  overall_height: String,
  overall_length: String,
  overall_width: String,
  std_seating: String,
  highway_mpg: Number,
  city_mpg: Number,
  powertrain_type: String,
});

const listingSchema = new mongoose.Schema({
  id: String,
  vin: String,
  heading: String,
  miles: Number,
  data_source: String,
  vdp_url: String,
  carfax_1_owner: Boolean,
  carfax_clean_title: Boolean,
  exterior_color: String,
  base_ext_color: String,
  dom: Number,
  dom_180: Number,
  dom_active: Number,
  dos_active: Number,
  seller_type: String,
  inventory_type: String,
  last_seen_at: Number,
  last_seen_at_date: Date,
  scraped_at: Number,
  scraped_at_date: Date,
  first_seen_at: Number,
  first_seen_at_date: Date,
  first_seen_at_source: Number,
  first_seen_at_source_date: Date,
  first_seen_at_mc: Number,
  first_seen_at_mc_date: Date,
  ref_miles: Number,
  ref_miles_dt: Number,
  source: String,
  in_transit: Boolean,
  title_type: String,
  media: mediaSchema,
  dealer: dealerSchema,
  build: buildSchema,
});

const carSchema = new mongoose.Schema({
  num_found: Number,
  listings: [listingSchema],
});

module.exports = mongoose.model('Car', carSchema);
