// const jwt = require("jsonwebtoken");
// const ejs = require("ejs");
// const Joi = require("@hapi/joi");
// const path = require("path");
// const bcrypt = require("bcryptjs");
// const appConstant = require("../constant");
// const appMessages = require("../langs");
// const statusCodeList = require("../statusCodes");
// const messageList = require("../messages");

// const constant = appConstant.constant;
// const statusCode = statusCodeList.statusCodes.STATUS_CODE;
// const messages = messageList.messages.MESSAGES;

// const sendResponse = async (req, res, code, message, data) => {
//   try {
//     const lang =
//       req.headers["content-language"] || constant.LANGUAGE_TYPE.ENGLISH;
//     code = code || statusCode.SUCCESS;
//     message = message || messages.SUCCESS;
//     data = data || {};
//     return res.status(code).send({
//       statusCode: code,
//       message: appMessages[lang]["APP_MESSAGES"][message],
//       data: data,
//     });
//   } catch (error) {
//     throw error;
//   }
// };

// const sendErrorResponse = async (req, res, code, error) => {
//   try {
//     const lang =
//       req.headers["content-language"] || constant.LANGUAGE_TYPE.ENGLISH;
//     code = code || statusCode.BAD_REQUEST;
//     error = appMessages[lang]["APP_MESSAGES"][error]
//       ? appMessages[lang]["APP_MESSAGES"][error]
//       : error;
//     return res.status(code).send({
//       statusCode: code,
//       error: error,
//       message: error,
//     });
//   } catch (error) {
//     throw error;
//   }
// };

// const forBiddenResponse = async (req, res, message) => {
//   try {
//     const lang =
//       req.headers["content-language"] || constant.LANGUAGE_TYPE.ENGLISH;
//     const code = statusCode.FORBIDDEN;
//     message = message || messages.FORBIDDEN;
//     return res.status(code).send({
//       statusCode: code,
//       message: appMessages[lang]["APP_MESSAGES"][message],
//       data: {},
//     });
//   } catch (error) {
//     throw error;
//   }
// };

// const unauthorizedResponse = async (req, res, message) => {
//   try {
//     const lang =
//       req.headers["content-language"] || constant.LANGUAGE_TYPE.ENGLISH;
//     const code = statusCode.UNAUTHORIZED;
//     message = message || messages.UNAUTHORIZED;
//     return res.status(code).send({
//       statusCode: code,
//       message: appMessages[lang]["APP_MESSAGES"][message],
//       data: {},
//     });
//   } catch (error) {
//     throw error;
//   }
// };

// const jwtVerify = async (token) => {
//   let checkingToken = token.split(" ")[1];
//   try {
//     return jwt.verify(checkingToken, process.env.JWT_SECRET_KEY);
//   } catch (error) {
//     throw error;
//   }
// };

// const securePassword = async (password) => {
//   let passwordHash = await bcrypt.hash(password, 10);
//   return passwordHash;
// };

// const renderTemplateFile = async () => {
//   let viewPath = path.join(__dirname, "../view/accountVerify.ejs");
//   let data = ejs.renderFile(viewPath);
//   return data;
// };

// const randomStringGenerator = (stringLenth) => {
//   let randomString = "";
//   let characters =
//     "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123654789abcdefghijklmnopqrstuvwxyz";
//   for (let i = 0; i < stringLenth; i++) {
//     randomString += characters.charAt(
//       Math.floor(Math.random() * characters.length)
//     );
//   }
//   return randomString;
// };

// const otpCodeGenerator = () => {
//   return Math.floor(Math.random() * 100000 + 100000);
// };

// const validateSchema = async (inputs, schema) => {
//   try {
//     const { error, value } = Joi.validate(inputs, schema);
//     if (error) throw error.details ? error.details[0].message : "";
//     else return false;
//   } catch (error) {
//     throw error;
//   }
// };

// const emailVerificationLink = (page, userEmail) => {
//   const emailLink = jwt.sign({ email: userEmail }, process.env.JWT_SECRET_KEY, {
//     expiresIn: "300s",
//   });
//   const url = `https://liberty-program-frontend.vercel.app/${page}?verification=${emailLink}`;
//   return url;
// };

// const comparePasswordUsingBcrypt = async (pass, hash) => {
//   return bcrypt.compareSync(pass, hash);
// };

// const jwtSign = async (payload) => {
//   try {
//     return jwt.sign({ _id: payload._id }, process.env.JWT_SECRET_KEY, {
//       expiresIn: "1h",
//     });
//   } catch (error) {
//     throw error;
//   }
// };

// module.exports = {
//   forBiddenResponse,
//   jwtVerify,
//   otpCodeGenerator,
//   randomStringGenerator,
//   renderTemplateFile,
//   securePassword,
//   sendErrorResponse,
//   sendResponse,
//   unauthorizedResponse,
//   validateSchema,
//   emailVerificationLink,
//   comparePasswordUsingBcrypt,
//   jwtSign,
// };



const jwt=require("jsonwebtoken")
const bcrypt=require("bcrypt")
const multer=require("multer")

const successFunction=(req,res,statusCode,message,data)=>{
    res.status(statusCode).send({
        statusCode:statusCode,
        message:message,
        data:data
    })
}

const errorFunction=(req,res,statusCode,message)=>{
    res.status(statusCode).send({
        statusCode:statusCode,
        message:message
    })
}

const generateToken=(email)=>{
    const accessToken=jwt.sign({email:email},"CARvadvdsvfdsv")
    return accessToken
}

const securePassword=async(password)=>{
    const hashPassword=await bcrypt.hash(password,10) 
    return hashPassword
}

const verifyPassword=async(password,hashPassword)=>{
    const comparePassword=await bcrypt.compare(password,hashPassword)
    return comparePassword
}

const config=multer.diskStorage({
    destination:(req,file,callback)=>{
        callback(null,"./uploads")
    },
    filename:(req,file,callback)=>{
        callback(null,`image-${Date.now()}${file.originalname}`)
    }
})

const isimg=(req,file,callback)=>{
    if(file.mimetype=="image/jpeg" || file.mimetype=="image/png"){
        callback(null,true)
    }
    else{
        callback(new Error("Only image can be uploaded"))
    }
}

const upload=multer({
    storage:config,
    fileFilter:isimg
})

module.exports={
    successFunction,
    errorFunction,
    generateToken,
    securePassword,
    verifyPassword,
    upload
}